package view 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.ui.Mouse;
	import flash.text.TextField;
	
	import event.FishShowEvent;
	import event.FishEatEvent;
	import event.PlayerHurtEvent;
	import event.HitObjectEvent;
	
	import Controll.HitObjectCommand;
	import Controll.FishShowCommand;
	import Controll.FishEatCommand;
	import Controll.PlayerHurtCommand;

	import view.Fish;
	import view.Player;
	import model.DataModel;
	
	/**
	 * ...
	 * @author june
	 */
	public class FishStage extends Sprite
	{
		
		private var _scoreTxt:TextField = new TextField();
		private var _fishWord:Sprite = new Sprite();
		
		private var _delay:Number = Math.floor(Math.random() * 1000 + 300);
		private var _repeatCount:uint = 0;
		private var _addFishTime:Timer = new Timer(_delay, _repeatCount);
		
		private var _tempPos:int;												//主角的现在坐标
		private var _bo:Boolean = true;											//左右方向
		private var _speed:uint = 5; 											//鼠标缓动速度
		private var _disString:String = "left";
		
		public function FishStage()
		{
			if (stage) init()
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void
		{
			trace("初始化");
			this.removeEventListener(Event.ADDED_TO_STAGE, init);
			stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
			this.addEventListener(Event.ENTER_FRAME,enterFrameHandler)
			var player:Player = new Player();
			DataModel.getInstance().playerState = player.state;
			DataModel.getInstance().player = player;
			this.addChild(_fishWord);
			this.addChild(player);
			
			_scoreTxt.text = DataModel.getInstance().score.toString();
			DataModel.getInstance().scoreText = _scoreTxt;
			_scoreTxt.x = 500;
			_scoreTxt.y = 10;
			this.addChild(DataModel.getInstance().scoreText)

			_addFishTime.addEventListener(TimerEvent.TIMER, AddFish);
			_addFishTime.start();
		}
		
		private function mouseMoveHandler(e:MouseEvent):void
		{
			Mouse.hide();

			DataModel.getInstance().player.x = stage.mouseX;
			DataModel.getInstance().player.y = stage.mouseY;
			
			e.updateAfterEvent();
			if (_bo == true)
			{
				_tempPos = DataModel.getInstance().player.x;
				_bo = false
			}
			var nowPos:int = stage.mouseX;
			if (nowPos > _tempPos)									//右边
			{
				if (_disString == "left")
				{
					DataModel.getInstance().player.scaleX = -1 * DataModel.getInstance().player.scaleX;
					_disString = "right"
				}
				_bo = true;
			}
			if (nowPos < _tempPos)									//左边
			{
				if (_disString == "right")
				{
					DataModel.getInstance().player.scaleX = -1 * DataModel.getInstance().player.scaleX;
					_disString = "left"
				}
				_bo = true;
			}
		}
		
		private function AddFish(e:TimerEvent):void
		{
			var fish:Fish = new Fish();
			_fishWord.addChild(fish);
			
			var fishShowEvt:FishShowEvent = new FishShowEvent(FishShowEvent.FISHSHOW);
			fishShowEvt.fishTarget = fish as Fish;
			
			var fishShowCmd:FishShowCommand = new FishShowCommand();
			fishShowCmd.dispatchEvent(fishShowEvt);
		}
		
		private function enterFrameHandler(e:Event):void
		{
			//分数检测
			_scoreTxt.text = DataModel.getInstance().score.toString();
			
			//游戏结束检测
			if (DataModel.getInstance().gameOver == true) removeAll();
			
			//鼠标缓动  先不用
			/*var tempX:Number=(stage.mouseX-DataModel.getInstance().player.x)/_speed;
			var tempY:Number=(stage.mouseY-DataModel.getInstance().player.y)/_speed;
			DataModel.getInstance().player.x += tempX;
			DataModel.getInstance().player.y += tempY;*/
			
			//碰撞检测
			var len = _fishWord.numChildren;
			var tempPlayer:Player = DataModel.getInstance().player;
			for (var i:int = 0; i < len ; i++ )
			{
				var tempFish:Fish = _fishWord.getChildAt(i) as Fish;
				if (tempFish.hitTestObject(tempPlayer))
				{
					var hitObjectEvt:HitObjectEvent = new HitObjectEvent(HitObjectEvent.HITOBJECT);
					hitObjectEvt.fishTarget = tempFish;
					hitObjectEvt.playerTarget = tempPlayer;
					
					var hitObjectCmd:HitObjectCommand = new HitObjectCommand();
					hitObjectCmd.dispatchEvent(hitObjectEvt);
					return;
				}
			}
		}
		
		private function removeAll():void
		{
			for (var i:uint = 0; i < _fishWord.numChildren - 1; i ++ )
			{
				var tempFish:Fish = _fishWord.getChildAt(i) as Fish;
				tempFish.fishDie();
			}
			while (this.numChildren > 0)
			{
				this.removeChildAt(0);
			}
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
			this.removeEventListener(Event.ENTER_FRAME, enterFrameHandler);
			_addFishTime.removeEventListener(TimerEvent.TIMER, AddFish);
			_addFishTime.stop();
			
			var loseMc:LoseMc = new LoseMc();
			this.addChild(loseMc);
			loseMc.x = this.stage.stageWidth / 2;
			loseMc.y = this.stage.stageHeight / 2;
		}
	}

}

